diff --git a/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePackDefault.java b/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePackDefault.java
index a02869ba9..0ac96cf24 100644
--- a/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePackDefault.java
+++ b/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePackDefault.java
@@ -9,65 +9,54 @@ import javax.imageio.ImageIO;
 import com.mojang.logging.LogUtils;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.holiday.Holidays;
+import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.texture.TextureBuffered;
 import org.slf4j.Logger;
 
-public class TexturePackDefault extends TexturePack
-{
+public class TexturePackDefault extends TexturePack {
     private static final Logger LOGGER = LogUtils.getLogger();
     private TextureBuffered texturePackThumbnailTexture;
     private BufferedImage texturePackThumbnail;
 
-    public TexturePackDefault()
-    {
-        texturePackThumbnailTexture = null;
-        fileName = "Default";
-        manifest = new Manifest(null, TexturePackDefault.class.getResourceAsStream("/manifest.json"));
-        try
-        {
-            texturePackThumbnail = ImageIO.read(TexturePackDefault.class.getResource("/pack.png"));
-        }
-        catch(IOException e)
-        {
-            LOGGER.error("Failed to read thumbnail for '{}'!", packId, e);
+    public TexturePackDefault() {
+        this.texturePackThumbnailTexture = null;
+        this.fileName = "Default";
+        this.manifest = new Manifest(null, TexturePackDefault.class.getResourceAsStream("/manifest.json"));
+        try {
+            this.texturePackThumbnail = ImageIO.read(TexturePackDefault.class.getResource("/pack.png"));
+        } catch (IOException e) {
+            LOGGER.error("Failed to read thumbnail for '{}'!", this.packId, e);
         }
     }
 
     @Override
-    public void disposeOfTexturePack(Minecraft minecraft)
-    {
-        if(texturePackThumbnail != null) {
-            texturePackThumbnailTexture.delete();
-            texturePackThumbnailTexture = null;
+    public void disposeOfTexturePack(Minecraft minecraft) {
+        if (this.texturePackThumbnail != null) {
+            this.texturePackThumbnailTexture.delete();
+            this.texturePackThumbnailTexture = null;
         }
     }
 
     @Override
-    public void bindThumbnailTexture(Minecraft minecraft)
-    {
-        if(texturePackThumbnail != null && texturePackThumbnailTexture == null)
-        {
-            texturePackThumbnailTexture = minecraft.textureManager.loadBufferedTexture(texturePackThumbnail);
-        }
-        if(texturePackThumbnail != null)
-        {
-            minecraft.textureManager.bindTexture(texturePackThumbnailTexture);
+    public void bindThumbnailTexture(Minecraft minecraft) {
+        if (this.texturePackThumbnail != null && this.texturePackThumbnailTexture == null) {
+            this.texturePackThumbnailTexture = minecraft.textureManager.loadBufferedTexture(this.texturePackThumbnail);
         }
-        else
-        {
+        if (this.texturePackThumbnail != null) {
+            minecraft.textureManager.bindTexture(this.texturePackThumbnailTexture);
+        } else {
             minecraft.textureManager.loadTexture("/assets/minecraft/textures/gui/unknown_pack.png").bind();
         }
     }
 
     @Override
     public boolean hasFile(String file) {
-		try
-        {
-			InputStream stream = TexturePackDefault.class.getResourceAsStream(file);
+        try {
+            InputStream stream = TexturePackDefault.class.getResourceAsStream(file);
             if (stream != null) {
                 stream.close();
                 return true;
-            } else if (Minecraft.getMinecraft().gameSettings.enableHolidayTextures.value && Holidays.getCurrentThemedHoliday() != null) {
+            } else if (GameSettings.ENABLE_HOLIDAY_TEXTURES.value && Holidays.getCurrentThemedHoliday() != null) {
                 assert Holidays.getCurrentThemedHoliday().getCustomResourcesSubPath() != null : "Current themed holiday must have a theme!";
                 String holidayPath = ("/holidays/" + Holidays.getCurrentThemedHoliday().getCustomResourcesSubPath() + "/" + file).replace("//", "/");
                 InputStream holidayStream = TexturePack.class.getResourceAsStream(holidayPath);
@@ -77,10 +66,8 @@ public class TexturePackDefault extends TexturePack
                 }
             }
             return false;
-		}
-        catch (Exception e)
-        {
-			return false;
-		}
-	}
+        } catch (Exception e) {
+            return false;
+        }
+    }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java b/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java
index 5e70813f2..16420a84f 100644
--- a/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java
+++ b/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java
@@ -4,6 +4,7 @@ import com.mojang.logging.LogUtils;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.TooltipElement;
 import net.minecraft.client.gui.keyboard.KeyboardLayout;
+import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.EntityRendererDispatcher;
 import net.minecraft.client.render.TileEntityRenderDispatcher;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
@@ -49,62 +50,62 @@ public class TexturePackList
 	}
 
 	public void shiftPack(TexturePack pack, int shiftAmount){
-		if (!selectedPacks.contains(pack)) return;
+		if (!this.selectedPacks.contains(pack)) return;
 		if (shiftAmount == 0) return;
-		int currentIndex = selectedPacks.indexOf(pack);
+		int currentIndex = this.selectedPacks.indexOf(pack);
 		int newIndex = currentIndex + shiftAmount;
 		if (newIndex < 0){
 			newIndex = 0;
 		}
-		if (newIndex >= selectedPacks.size()){
-			newIndex = selectedPacks.size() - 1;
+		if (newIndex >= this.selectedPacks.size()){
+			newIndex = this.selectedPacks.size() - 1;
 		}
-		selectedPacks.remove(pack);
-		selectedPacks.add(newIndex, pack);
+        this.selectedPacks.remove(pack);
+        this.selectedPacks.add(newIndex, pack);
 		savePacksToSettings();
-		isDirty = true;
+        this.isDirty = true;
 	}
     public void setTexturePack(TexturePack newPack)
     {
-		if (!selectedPacks.contains(newPack)){
-			selectedPacks.add(newPack);
+		if (!this.selectedPacks.contains(newPack)){
+            this.selectedPacks.add(newPack);
 			newPack.readZipFile();
 			savePacksToSettings();
-			isDirty = true;
+            this.isDirty = true;
 		}
     }
 	public void savePacksToSettings(){
-		mc.gameSettings.skin.value = packSaveString();
-		mc.gameSettings.saveOptions();
+		GameSettings.SKIN.value = packSaveString();
+		GameSettings.saveOptions();
 	}
 	public String packSaveString(){
 		StringBuilder builder = new StringBuilder();
-		for (TexturePack pack : selectedPacks){
-			if (pack == defaultTexturePack) continue;
+		for (TexturePack pack : this.selectedPacks){
+			if (pack == this.defaultTexturePack) continue;
 			builder.append(pack.fileName).append(SEPERATOR);
 		}
 		return builder.toString();
 	}
 	public void unsetTexturePack(TexturePack pack){
 		pack.closeTexturePackFile();
-		selectedPacks.remove(pack);
+        this.selectedPacks.remove(pack);
 		savePacksToSettings();
-		isDirty = true;
+        this.isDirty = true;
 	}
 	public void refreshIfReady(){
-		if (isDirty){
-			isDirty = false;
+		if (this.isDirty){
+            this.isDirty = false;
 			refresh();
 		}
 	}
 
 	public void refresh() {
-		mc.textureManager.refreshTexturesAndDisplayErrors();
-		mc.renderGlobal.allChanged();
-		if (mc.currentScreen != null) {
-			mc.currentScreen.updateFont();
+        this.mc.textureManager.refreshTexturesAndDisplayErrors();
+        this.mc.renderGlobal.allChanged();
+		if (this.mc.currentScreen != null) {
+            this.mc.currentScreen.updateFont();
 		}
-		mc.textureManager.updateDynamicTextures(false);
+        this.mc.textureManager.updateDynamicTextures(false);
 		SoundRepository.reload();
 		BlockColorDispatcher.getInstance().reload();
 		BlockModelDispatcher.getInstance().reload();
@@ -121,12 +122,12 @@ public class TexturePackList
 
 		boolean update = false;
 
-		if(texturePackDir.exists() && texturePackDir.isDirectory()) {
-			File[] filesArr = texturePackDir.listFiles();
+		if(this.texturePackDir.exists() && this.texturePackDir.isDirectory()) {
+			File[] filesArr = this.texturePackDir.listFiles();
 
 			if(filesArr != null) {
                 List<File> fileList = new ArrayList<>(Arrays.asList(filesArr));
-				if (mc.gameSettings.enableDevResourceLoading.value) { // Load project resources as an available texture pack
+				if (GameSettings.ENABLE_DEV_RESOURCE_LOADING.value) { // Load project resources as an available texture pack
 					File resources = new File("./src/main/resources");
 					fileList.add(resources);
 
@@ -143,18 +144,18 @@ public class TexturePackList
 					}
 					String id = getTexturePackID(file);
 					try {
-						if(!texturePackIDs.containsKey(id)) {
+						if(!this.texturePackIDs.containsKey(id)) {
 							TexturePackCustom pack = new TexturePackCustom(file);
 							pack.packId = id;
 							pack.readZipFile();
 							pack.readTexturePackManifest();
 
-							texturePackIDs.put(id, pack);
+                            this.texturePackIDs.put(id, pack);
 							pack.closeTexturePackFile();
 							update = true;
 						}
 
-						TexturePack pack = texturePackIDs.get(id);
+						TexturePack pack = this.texturePackIDs.get(id);
 						currentTexturePacks.add(pack);
 					}catch (IOException e) {
                         LOGGER.error("Failed to make texturepack for file '{}'!", file.getPath(), e);
@@ -170,18 +171,18 @@ public class TexturePackList
 		}
 
 		for(TexturePack texturePack : previousTexturePacks) {
-			texturePack.disposeOfTexturePack(mc);
-			texturePackIDs.remove(texturePack.packId);
+			texturePack.disposeOfTexturePack(this.mc);
+            this.texturePackIDs.remove(texturePack.packId);
 		}
 
 		this.availableTexturePacks = currentTexturePacks;
 
-		String[] packStrings = mc.gameSettings.skin.value.split(SEPERATOR);
+		String[] packStrings = GameSettings.SKIN.value.split(SEPERATOR);
 		for (String string : packStrings){
-			for (TexturePack pack : availableTexturePacks){
-				if (string.equals(pack.fileName) && !selectedPacks.contains(pack)){
+			for (TexturePack pack : this.availableTexturePacks){
+				if (string.equals(pack.fileName) && !this.selectedPacks.contains(pack)){
 					pack.readZipFile();
-					selectedPacks.add(pack);
+                    this.selectedPacks.add(pack);
 				}
 			}
 		}
@@ -213,32 +214,32 @@ public class TexturePackList
 
     public List<TexturePack> availableTexturePacks()
     {
-        return new ArrayList<>(availableTexturePacks);
+        return new ArrayList<>(this.availableTexturePacks);
     }
     public List<TexturePack> selectedTexturePacks()
     {
-        return new ArrayList<>(selectedPacks);
+        return new ArrayList<>(this.selectedPacks);
     }
 
     public TexturePack getDefaultTexturePack()
     {
-        return defaultTexturePack;
+        return this.defaultTexturePack;
     }
 	public InputStream getResourceAsStream(String s){
 		return getResourceAsStream(s, true);
 	}
 	private InputStream getResourceAsStream(String s, boolean firstCall) {
 		InputStream stream;
-		for (int i = selectedPacks.size() - 1; i >= 0; i--) {
-			TexturePack pack = selectedPacks.get(i);
+		for (int i = this.selectedPacks.size() - 1; i >= 0; i--) {
+			TexturePack pack = this.selectedPacks.get(i);
 			stream = pack.getResourceAsStream(s);
 			if (stream != null) return stream;
 		}
-		return defaultTexturePack.getResourceAsStream(s);
+		return this.defaultTexturePack.getResourceAsStream(s);
 	}
 	public TexturePack getHighestPriorityPack(){
-		if (selectedPacks.isEmpty()) return defaultTexturePack;
-		return selectedPacks.get(selectedPacks.size()-1);
+		if (this.selectedPacks.isEmpty()) return this.defaultTexturePack;
+		return this.selectedPacks.get(this.selectedPacks.size()-1);
 	}
 
 	public boolean anyHasFile(String path) {
@@ -252,14 +253,14 @@ public class TexturePackList
 		return getHighestPriorityTexturePackWithFile(path, true);
 	}
 	private @Nullable TexturePack getHighestPriorityTexturePackWithFile(String path, boolean firstCall) {
-		for(int i = selectedPacks.size() - 1; i >= 0; i--) {
-			TexturePack texturePack = selectedPacks.get(i);
+		for(int i = this.selectedPacks.size() - 1; i >= 0; i--) {
+			TexturePack texturePack = this.selectedPacks.get(i);
 			if(texturePack.hasFile(path)) {
 				return texturePack;
 			}
 		}
-		if(defaultTexturePack.hasFile(path)) {
-			return defaultTexturePack;
+		if(this.defaultTexturePack.hasFile(path)) {
+			return this.defaultTexturePack;
 		}
 		return null;
 	}
diff --git a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererJarButterfly.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererJarButterfly.java
index 6c5206ab9..c813ce39b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererJarButterfly.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererJarButterfly.java
@@ -2,12 +2,17 @@ package net.minecraft.client.render.tileentity;
 
 import net.minecraft.client.render.entity.MobRendererButterfly;
 import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.core.block.BlockLogicJarButterfly;
 import net.minecraft.core.block.entity.TileEntityJarButterfly;
 import net.minecraft.core.util.helper.MathHelper;
 
 public class TileEntityRendererJarButterfly extends TileEntityRenderer<TileEntityJarButterfly>{
     @Override
     public void doRender(TessellatorGeneral tessellator, TileEntityJarButterfly tileEntity, double x, double y, double z, float partialTick) {
-        MobRendererButterfly.drawButterfly(tessellator, tileEntity.ticksRan, 0.70f, 0, x + 0.5, y - 0.125 + MathHelper.sin((tileEntity.ticksRan + partialTick)/20) * (0.0625), z + 0.5, partialTick, renderDispatcher.textureManager, "/assets/minecraft/textures/entity/butterfly/" + tileEntity.color.name + "/0_0.png");
+        int meta = tileEntity.getBlockMeta();
+        boolean hanging = (meta & BlockLogicJarButterfly.MASK_HANGING) != 0;
+        MobRendererButterfly.drawButterfly(tessellator, tileEntity.ticksRan, 0.70f, 0,
+            x + 0.5, y + (hanging ? 6/16f : 0) - 0.125 + MathHelper.sin((tileEntity.ticksRan + partialTick)/20) * (0.0625), z + 0.5,
+            partialTick, this.renderDispatcher.textureManager, "/assets/minecraft/textures/entity/butterfly/" + tileEntity.color.name + "/0_0.png");
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMeshGold.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMeshGold.java
index 209b75455..842d66d02 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMeshGold.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMeshGold.java
@@ -1,5 +1,6 @@
 package net.minecraft.client.render.tileentity;
 
+import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.core.block.entity.TileEntityMeshGold;
 
@@ -23,7 +24,7 @@ public class TileEntityRendererMeshGold extends TileEntityRenderer<TileEntityMes
 
 
         ItemModelDispatcher.getInstance().getDispatch(tileEntity.filterItem).renderItemEntity(tessellator, tileEntity.filterItem,
-            Minecraft.getMinecraft().gameSettings.items3D.value, 1, tileEntity.ticksRan, yaw,
+            GameSettings.ITEMS_3D.value, 1, tileEntity.ticksRan, yaw,
             Minecraft.getMinecraft().currentWorld.getLightmapCoord(new TilePos(tileEntity.x, tileEntity.y, tileEntity.z), 0), renderPartialTicks);
         GLRenderer.popFrame();
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
index 2b4620b52..73fac9b52 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
@@ -2,8 +2,9 @@ package net.minecraft.client.render.tileentity;
 
 import it.unimi.dsi.fastutil.ints.IntArrayList;
 import it.unimi.dsi.fastutil.ints.IntList;
-import net.minecraft.client.GLAllocation;
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.option.GameSettings;
+import net.minecraft.client.option.enums.TextOutlineQuality;
 import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.camera.ICamera;
 import net.minecraft.client.render.font.FontRenderer;
@@ -23,7 +24,6 @@ import net.minecraft.core.enums.EnumSignPicture;
 import net.minecraft.core.util.helper.Color;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
 import org.joml.Math;
 import org.joml.primitives.AABBd;
@@ -152,7 +152,7 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign> {
         }
         final int _x = 0;
         final int _y = -tileEntity.signText.length * 5;
-        if (tileEntity.isGlowing() && this.mc.gameSettings.fancyGraphics.value >= 1) {
+        if (tileEntity.isGlowing() && GameSettings.TEXT_OUTLINE_QUALITY.value == TextOutlineQuality.FANCY) {
             this.textMeshRenderer.render(sr, t, line1, line2, line3, line4, _x, _y, SF.setOutlined(SF.setColor(0, color)));
         } else {
             this.textMeshRenderer.render(sr, t, line1, line2, line3, line4, _x, _y, SF.setColor(0, color));
diff --git a/game/client/src/main/java/net/minecraft/client/render/window/GameWindow.java b/game/client/src/main/java/net/minecraft/client/render/window/GameWindow.java
index ade0cb6e0..c4a65237b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/window/GameWindow.java
+++ b/game/client/src/main/java/net/minecraft/client/render/window/GameWindow.java
@@ -1,7 +1,6 @@
 package net.minecraft.client.render.window;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.core.UnexpectedThrowable;
 
 public interface GameWindow {
 	
@@ -10,8 +9,9 @@ public interface GameWindow {
 	void toggleFullscreen();
 	
 	void updateWindowState();
-	
-	void displayCrashReport(UnexpectedThrowable unexpectedThrowable, int cause);
+
+	// Does not work with headless mode set to false
+//	void displayCrashReport(UnexpectedThrowable unexpectedThrowable, int cause);
 	
 	int getFrequency();
 	
diff --git a/game/client/src/main/java/net/minecraft/client/render/window/GameWindowGLFW.java b/game/client/src/main/java/net/minecraft/client/render/window/GameWindowGLFW.java
index e973bd7e1..ce70ed33c 100644
--- a/game/client/src/main/java/net/minecraft/client/render/window/GameWindowGLFW.java
+++ b/game/client/src/main/java/net/minecraft/client/render/window/GameWindowGLFW.java
@@ -1,25 +1,12 @@
 package net.minecraft.client.render.window;
 
-import static org.lwjgl.glfw.GLFW.*;
-import static org.lwjgl.system.MemoryUtil.NULL;
-
-import java.awt.*;
-import java.io.IOException;
-import java.io.InputStream;
-import java.lang.reflect.InvocationTargetException;
-import java.lang.reflect.Method;
-import java.nio.ByteBuffer;
-import java.util.ArrayList;
-import java.util.HashMap;
-import java.util.List;
-import java.util.Map;
-import java.nio.IntBuffer;
-import java.util.Objects;
-
-import javax.swing.JFrame;
-
-import com.mojang.logging.CategorizedLogger;
+import com.github.zarzelcow.legacylwjgl3.implementation.glfw.GLFWKeyboardImplementation;
+import com.github.zarzelcow.legacylwjgl3.implementation.glfw.GLFWMouseImplementation;
+import com.github.zarzelcow.legacylwjgl3.implementation.input.CombinedInputImplementation;
+import com.github.zarzelcow.legacylwjgl3.implementation.input.InputImplementation;
 import com.mojang.logging.LogUtils;
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.OpenGLHelper;
 import net.minecraft.client.util.debug.GLFWLoggerCallback;
 import net.minecraft.client.util.debug.OpenGLLoggerCallback;
@@ -37,21 +24,72 @@ import org.lwjgl.glfw.GLFWImage;
 import org.lwjgl.glfw.GLFWVidMode;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.input.Mouse;
-import org.lwjgl.opengl.*;
-
-import com.github.zarzelcow.legacylwjgl3.implementation.glfw.GLFWKeyboardImplementation;
-import com.github.zarzelcow.legacylwjgl3.implementation.glfw.GLFWMouseImplementation;
-import com.github.zarzelcow.legacylwjgl3.implementation.input.CombinedInputImplementation;
-import com.github.zarzelcow.legacylwjgl3.implementation.input.InputImplementation;
-
-import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.PanelCrashReport;
-import net.minecraft.core.UnexpectedThrowable;
+import org.lwjgl.opengl.Display;
+import org.lwjgl.opengl.GL;
+import org.lwjgl.opengl.GL41;
+import org.lwjgl.opengl.GL43;
+import org.lwjgl.opengl.GLCapabilities;
+import org.lwjgl.opengl.GLDebugMessageCallback;
 import org.lwjgl.stb.STBImage;
 import org.lwjgl.system.MemoryStack;
 import org.lwjgl.system.MemoryUtil;
 import org.slf4j.Logger;
 
+import java.io.IOException;
+import java.io.InputStream;
+import java.lang.reflect.InvocationTargetException;
+import java.lang.reflect.Method;
+import java.nio.ByteBuffer;
+import java.nio.IntBuffer;
+import java.util.ArrayList;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+import java.util.Objects;
+
+import static org.lwjgl.glfw.GLFW.GLFW_ARROW_CURSOR;
+import static org.lwjgl.glfw.GLFW.GLFW_AUTO_ICONIFY;
+import static org.lwjgl.glfw.GLFW.GLFW_CONTEXT_VERSION_MAJOR;
+import static org.lwjgl.glfw.GLFW.GLFW_CONTEXT_VERSION_MINOR;
+import static org.lwjgl.glfw.GLFW.GLFW_CROSSHAIR_CURSOR;
+import static org.lwjgl.glfw.GLFW.GLFW_DECORATED;
+import static org.lwjgl.glfw.GLFW.GLFW_HAND_CURSOR;
+import static org.lwjgl.glfw.GLFW.GLFW_HRESIZE_CURSOR;
+import static org.lwjgl.glfw.GLFW.GLFW_IBEAM_CURSOR;
+import static org.lwjgl.glfw.GLFW.GLFW_OPENGL_FORWARD_COMPAT;
+import static org.lwjgl.glfw.GLFW.GLFW_RESIZABLE;
+import static org.lwjgl.glfw.GLFW.GLFW_TRUE;
+import static org.lwjgl.glfw.GLFW.GLFW_VISIBLE;
+import static org.lwjgl.glfw.GLFW.GLFW_VRESIZE_CURSOR;
+import static org.lwjgl.glfw.GLFW.glfwCreateWindow;
+import static org.lwjgl.glfw.GLFW.glfwGetError;
+import static org.lwjgl.glfw.GLFW.glfwGetFramebufferSize;
+import static org.lwjgl.glfw.GLFW.glfwGetMonitorPos;
+import static org.lwjgl.glfw.GLFW.glfwGetMonitors;
+import static org.lwjgl.glfw.GLFW.glfwGetPrimaryMonitor;
+import static org.lwjgl.glfw.GLFW.glfwGetVideoMode;
+import static org.lwjgl.glfw.GLFW.glfwGetWindowMonitor;
+import static org.lwjgl.glfw.GLFW.glfwGetWindowPos;
+import static org.lwjgl.glfw.GLFW.glfwGetWindowSize;
+import static org.lwjgl.glfw.GLFW.glfwHideWindow;
+import static org.lwjgl.glfw.GLFW.glfwInit;
+import static org.lwjgl.glfw.GLFW.glfwMakeContextCurrent;
+import static org.lwjgl.glfw.GLFW.glfwPollEvents;
+import static org.lwjgl.glfw.GLFW.glfwSetFramebufferSizeCallback;
+import static org.lwjgl.glfw.GLFW.glfwSetWindowAttrib;
+import static org.lwjgl.glfw.GLFW.glfwSetWindowFocusCallback;
+import static org.lwjgl.glfw.GLFW.glfwSetWindowIcon;
+import static org.lwjgl.glfw.GLFW.glfwSetWindowMonitor;
+import static org.lwjgl.glfw.GLFW.glfwSetWindowPos;
+import static org.lwjgl.glfw.GLFW.glfwSetWindowSize;
+import static org.lwjgl.glfw.GLFW.glfwSetWindowSizeCallback;
+import static org.lwjgl.glfw.GLFW.glfwShowWindow;
+import static org.lwjgl.glfw.GLFW.glfwSwapBuffers;
+import static org.lwjgl.glfw.GLFW.glfwSwapInterval;
+import static org.lwjgl.glfw.GLFW.glfwWindowHint;
+import static org.lwjgl.glfw.GLFW.glfwWindowShouldClose;
+import static org.lwjgl.system.MemoryUtil.NULL;
+
 public class GameWindowGLFW implements GameWindow {
     public static final Logger LOGGER = LogUtils.getLogger();
 
@@ -86,7 +124,7 @@ public class GameWindowGLFW implements GameWindow {
     public void init(Minecraft minecraft, int width, int height) {
         this.mc = minecraft;
 
-        boolean debug = (this.mc.gameSettings.developerMode.value || Version.BUILD_CHANNEL == BuildChannel.DEVELOPMENT || Global.DEBUG_MODE);
+        boolean debug = (GameSettings.DEVELOPER_MODE.value || Version.BUILD_CHANNEL == BuildChannel.DEVELOPMENT || Global.DEBUG_MODE);
 
         LOGGER.info("Initializing GLFW...");
         if (debug) {
@@ -228,7 +266,7 @@ public class GameWindowGLFW implements GameWindow {
         }
 
         // Set Vsync
-        setVsync(this.mc.gameSettings.enableVsync.value);
+        setVsync(GameSettings.ENABLE_VSYNC.value);
     }
 
     @Override
@@ -278,7 +316,7 @@ public class GameWindowGLFW implements GameWindow {
 
     @Override
     public void toggleFullscreen() {
-        this.mc.gameSettings.fullscreen.value = !this.mc.gameSettings.fullscreen.value;
+        GameSettings.FULLSCREEN.value = !GameSettings.FULLSCREEN.value;
 
         updateWindowState();
     }
@@ -302,8 +340,8 @@ public class GameWindowGLFW implements GameWindow {
             }
         }
 
-        boolean fullscreen = this.mc.gameSettings.fullscreen.value;
-        boolean borderless = this.mc.gameSettings.borderlessFullscreen.value;
+        boolean fullscreen = GameSettings.FULLSCREEN.value;
+        boolean borderless = GameSettings.BORDERLESS_FULLSCREEN.value;
 
         glfwHideWindow(this.window);
 
@@ -357,19 +395,20 @@ public class GameWindowGLFW implements GameWindow {
         return new MonitorInfo(glfwGetPrimaryMonitor());
     }
 
-    @Override
-    public void displayCrashReport(UnexpectedThrowable unexpectedThrowable, int cause) {
-        JFrame frame = new JFrame();
-        Panel panel = new PanelCrashReport(this.mc, unexpectedThrowable, cause);
-
-        panel.setPreferredSize(new java.awt.Dimension(1280, 720));
-
-        frame.add(panel);
-        frame.pack();
-        frame.setLocationRelativeTo(null);
-        frame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
-        frame.setVisible(true);
-    }
+    // This does not work when headless mode is on
+//    @Override
+//    public void displayCrashReport(UnexpectedThrowable unexpectedThrowable, int cause) {
+//        JFrame frame = new JFrame();
+//        Panel panel = new PanelCrashReport(this.mc, unexpectedThrowable, cause);
+//
+//        panel.setPreferredSize(new java.awt.Dimension(1280, 720));
+//
+//        frame.add(panel);
+//        frame.pack();
+//        frame.setLocationRelativeTo(null);
+//        frame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
+//        frame.setVisible(true);
+//    }
 
     @Override
     public int getFrequency() {
@@ -453,10 +492,13 @@ public class GameWindowGLFW implements GameWindow {
 
     @Override
     public void free() {
-        Callbacks.glfwFreeCallbacks(this.window);
-        if (this.glfwErrorCallback != null) this.glfwErrorCallback.free();
-        if (this.glDebugMessageCallback != null) this.glDebugMessageCallback.free();
-        this.stbiIconImages.forEach(STBImage::stbi_image_free);
+        if (this.window != NULL) {
+            Callbacks.glfwFreeCallbacks(this.window);
+            this.window = NULL;
+            if (this.glfwErrorCallback != null) this.glfwErrorCallback.free();
+            if (this.glDebugMessageCallback != null) this.glDebugMessageCallback.free();
+            this.stbiIconImages.forEach(STBImage::stbi_image_free);
+        }
     }
 
     public static class MonitorInfo {
